<?php

/**
 * remision_titulo actions.
 *
 * @package    cobro_coactivo
 * @subpackage remision_titulo
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class remision_tituloActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CBR_REMISION_TITULO',
        'CBR_PAR',
        'CBR_REMISION_TIT_AGRUP_V',
        'CBR_APRUEBA_REPARTO_ULT_V',
        'CBR_APROB_DENEG_ULT_V',
        'CBR_ABOGADO_ULT_V',
        'CBR_PROCESO_COACTIVO',
        'CBR_RESOL_TIT_REMIS_V',
        'CBR_REMISION_TITULO_DET_V',
        'CBR_REMISION_LIQ_AGRUP_V'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CBR_PAR' =>
        array(
            'id_par' => 'CBR_REMISION_TITULO'
        ),
        'CBR_REMISION_TIT_AGRUP_V,LEFT' =>
        array(
            'id_remision_titulo' => 'CBR_REMISION_TITULO'
        ),
        'CBR_APRUEBA_REPARTO_ULT_V,LEFT' =>
        array(
            'id_remision_titulo' => 'CBR_REMISION_TITULO'
        ),
        'CBR_APROB_DENEG_ULT_V,LEFT' =>
        array(
            'id_remision_titulo' => 'CBR_REMISION_TITULO'
        ),
        'CBR_ABOGADO_ULT_V,LEFT' =>
        array(
            'id_remision_titulo' => 'CBR_REMISION_TITULO'
        )/* ,
          'CBR_PROCESO_COACTIVO,LEFT' =>
          array(
          'id_remision_titulo' => 'CBR_REMISION_TITULO'
          ) */,
        'CBR_RESOL_TIT_REMIS_V,LEFT' =>
        array(
            'id_remision_titulo' => 'CBR_REMISION_TITULO'
        ),
        'CBR_REMISION_TITULO_DET_V,LEFT' =>
        array(
            'id_remision_titulo' => 'CBR_REMISION_TITULO'
        ),
        'CBR_REMISION_LIQ_AGRUP_V,LEFT' =>
        array(
            'id_remision_titulo' => 'CBR_REMISION_TITULO'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CBR_REMISION_TITULO' =>
        array(
            'id_remision_titulo' => 'id_remision_titulo',
            'numero_remision' => 'numero_remision',
            'anho_remision' => 'anho_remision',
            'numero_correpondencia' => 'numero_correpondencia',
            'fecha_remision' => 'fecha_remision',
            'id_par' => 'id_par',
            'no_folios' => 'no_folios',
            'estado' => 'estado',
            'fecha_log' => 'fecha_log',
            'usuario_log' => 'usuario_log',
            'numero_remision,||, - ,||,anho_remision' => 'completo_remision'
        ),
        'CBR_REMISION_TIT_AGRUP_V' =>
        array(
            'cod_titulo_det_agrup' => 'cod_titulo_det_agrup',
            'observaciones_det_agrup' => 'observaciones_det_agrup',
            'mineral_det_agrup' => 'mineral_det_agrup'
        ),
        'CBR_PAR' =>
        array(
            'descripcion' => 'descripcion_par'
        ),
        'CBR_APRUEBA_REPARTO_ULT_V' =>
        array(
            'aprobado' => 'aprobado_rep'
        ),
        'CBR_APROB_DENEG_ULT_V' =>
        array(
            'aprobado' => 'aprobado_deneg'
        ),
        'CBR_ABOGADO_ULT_V' =>
        array(
            'id_abogado' => 'id_abogado',
            'num_doc' => 'num_doc',
            'razon_soc' => 'razon_soc'
        )/* ,
          'CBR_PROCESO_COACTIVO' =>
          array(
          'id_proceso_coactivo' => 'id_proceso_coactivo',
          'no_proceso' => 'no_proceso',
          'id_anhos' => 'id_anhos_proceso_coa',
          'fecha' => 'fecha_proceso_coa'
          ) */,
        'CBR_RESOL_TIT_REMIS_V' =>
        array(
            'no_resolucion' => 'no_resolucion',
            'date_expedicion' => 'date_expedicion',
            'no_resolucion_det' => 'no_resolucion_det',
            'date_expedicion_det' => 'date_expedicion_det',
            'no_resolucion_text' => 'no_resolucion_text',
            'date_expedicion_text' => 'date_expedicion_text',
            'no_resolucion_text_completa' => 'no_resolucion_text_completa'
        ),
        'CBR_REMISION_LIQ_AGRUP_V' =>
        array(
            'valor_capital' => 'valor_capital',
            'valor_interes' => 'valor_interes',
            'valor_abono' => 'valor_abono',
            'saldo' => 'saldo',
            'valor_abono_calc' => 'valor_abono_calc',
            'valor_acuerdo' => 'valor_acuerdo',
            'valor_embargo' => 'valor_embargo'
        )
    ); //por cada tabla especificar los campos del select
    protected $query_qualifier = 'DISTINCT'; //Variable para el sql para eliminar filas repetidas
    protected $fields_orderBy = array(
        'anho_remision desc', 'numero_remision desc', 'id_remision_titulo desc'
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CBR_REMISION_TITULO' =>
        array(
            'id_remision_titulo,a' => array('!=' => array(-1)),
            'id_remision_titulo,b' => array('=' => array('id_remision_titulo')),
            'id_par' => array('=' => array('id_par')),
            'estado' => array('=' => array('estado')),
            'numero_remision' => array('=' => array('numero_remision')),
            'anho_remision' => array('=' => array('anho_remision')),
            'numero_correpondencia' => array('=' => array('numero_correpondencia')),
            'no_folios' => array('=' => array('no_folios')),
            'fecha_remision' => array('BETWEENFECHA' => array('fecha_ini', 'fecha_fin')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'CBR_ABOGADO_ULT_V' =>
        array(
            'id_abogado' => array('=' => array('id_abogado')),
            'num_doc' => array('=' => array('num_doc'))
        ),
        'CBR_REMISION_TITULO_DET_V' =>
        array(
            'cod_titulo' => array('=' => array('cod_titulo'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_remision_titulo'; //identificador de la tabla
    protected $id_names = array('id_remision_titulo'); //llave primaria
    protected $field_names = array('numero_remision', 'anho_remision', 'numero_correpondencia',
        'fecha_remision', 'id_par', 'no_folios', 'estado', 'cod_titulo', 'usuario_log'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CBR_REMISION_TITULO'; //tabla en la cual se aplican los cambios 

    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_remision_titulo'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            /**
             * Actualizar consecutivo de remision - 20200221
             */
            try {

                $id_anhos = $list_data_post[0]['anho_remision'];
                $consecutivo = $list_data_post[0]['numero_remision'];

                //Valida exista consecutivo - 20170424
                if ($consecutivo != 1) {

                    $sql = <<<EOD
update cbr_consecutivo_remis set consecutivo =($consecutivo) where id_anhos = $id_anhos
EOD;
                    $this->conn->execute($sql);
                } else {

                    $request['numero_remision'] = 1;

                    $sql = <<<EOD
Insert into CBR_CONSECUTIVO_REMIS (ID_CONSECUTIVO_REMIS,ID_ANHOS,CONSECUTIVO) 
    values (null,'$id_anhos','$consecutivo') 
EOD;
                    $this->conn->execute($sql);
                }

                //COMMIT DE TODAS LAS TRANSACCIONES
                $this->conn->commit();
            } catch (Exception $ex) {
                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            //Campos de log - 20200221
            $request['usuario_log'] = $request['id_username'];

            //Reemplazar espacios en blanco - 20160217
            $request['cod_titulo'] = str_replace(' ', '', $request['cod_titulo']);

            $fecha_remision = $request['fecha_remision'];

            $sql = <<<EOD
select to_char(to_date('$fecha_remision','YYYY-MM-DD'),'YYYY') as ID_ANHOS FROM DUAL
EOD;

            $records = CN_TABLE::executeSQL($sql);

            $id_anhos = $records[0]['id_anhos'];
            $request['anho_remision'] = $id_anhos;

            $sql = <<<EOD
select consecutivo from cbr_consecutivo_remis where id_anhos = $id_anhos
EOD;
            $records = CN_TABLE::executeSQL($sql);

            //Valida exista consecutivo - 20170424
            if (count($records) > 0) {
                $consecutivo = $records[0]['consecutivo'];
                $request['numero_remision'] = $consecutivo + 1;
            } else {
                $request['numero_remision'] = 1;
            }
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

}
